' Homerseklet mero, termosztat program PICPLC8 / PICPLC16 mikrogepre, DS1820 szenzorral
' Proci : 16F1937
' A DS1820 egy egy vezetken - one wire - kommunikl hszenzor IC
' Rendelkezik egy 64 bites gyrilag programozott egyedi kddal, s egy RAM memrival,
' ahova a hmrsklet adatokat rakja. Az IC-t vezrl parancsokrl rszletes inft tallunk az adatlapjn 
' A PIC BASIC PRO nagyon megknnyti az egy vezetkes IC-kel trtn kommunikcit, mert 
' kt kln utastsa van erre, az owout a kldsre, owin az olvassra.
' A progi beolvassa a hmrskletet, az eredmnyt kirakja az LCD-re, valamint sszehasonltja kt megadott rtkkel,
' s az eredmnytl fggen kapcsolgatja a relt. 

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

    DQ	Var	PORTA.0		' DS1820 adatlaba, a DQ, a PORTA.0 labon

	       				' Megadjuk az LCD vezerlesi parametereit :
	DEFINE LCD_DREG 	PORTD	' Az LCD adatbitek a D porton,
	DEFINE LCD_DBIT 	0	' es az els bit az RD0.
	DEFINE LCD_RSREG 	PORTD	' A register select bit a D porton,
	DEFINE LCD_RSBIT 	4	' az RD4 port.
	DEFINE LCD_EREG 	PORTD	' Az enable bit a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva.
	DEFINE LCD_BITS 	4	' A 4 bites zemmodot valasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

   	RELE    VAR PORTA.5   ' A rel a PORTA 5-n van	
    hofok 	Var	Word	' A "hofok" valtozonak egy 2 bjtos helyet foglalok
    meres_ok Var Byte	' Allapotjelzo a mereshez
	
       					' Felszolitom a DS1820-at, hogy  csinaljon egy homerseklet merest!
main: 	OWOut DQ, 1, [$CC, $44]		'$CC parancs: ugorjuk t az IC azonost kdjt, $44 : mrj, az eredmnyt rakd a RAM-ba! 
					
meres: 	OWIn DQ, 4, [meres_ok]		' Varom hogy vegezzen... Amig a meres_ok = 0 , nincs kesz!
	If meres_ok = 0 Then meres 	' Csak ha a meres_ok mar nem nullat ad vissza, mehetunk tovabb.
					' Most mar beolvashatom a hofokot.
	OWOut DQ, 1, [$CC, $BE]		' Felszolitom a 1820-at, hogy kuldje az adatokat!
	       ' A $CC parancs miatt tugorjuk az IC azonost kdjt, a $BE pedig elkezdi bekldeni az IC RAM
           ' memrijnak bjtjait. De az 1-es md miatt csak az els kett bjtot adja be, utnna reset  
   	OWIn DQ, 0, [hofok.LOWBYTE, hofok.HIGHBYTE]	' Az adatokat "hofok" valtozoba olvasom.
	
    		' Most t kell szamolnom az eredmenyt Celsius fokra:
			' Egy bit, 0.5 foknak felel meg. (Pl. ha 51-et olvasok ki, az 25.5 C)
	hofok = hofok * 5		' Ha szorzom 5-el a hofok erteket, akkor homerseklet ertek 10-szereset kapom 
				' Pl. ha 51 volt a hofok valtozoban, akkor a muvelet utan 255 lesz.
	Lcdout $fe, 1, "Szenzor: ", DEC (hofok / 10), ".", DEC1 hofok, " C"	' Kirakom az eredmenyt az LCD-re

    Pause 1000      ' Egy masodperc szunet...

'Csinljunk egy htsvezrls !

	IF hofok >= 260 Then HIGH RELE 	' Ha 26.0 foknal melegebb van, rele be! 
	IF hofok <= 245 Then LOW RELE	' Ha 24.5 fok ala megy a homerseklet, rele ki!

	Goto main			' Do it forever...
